# AnyKernel2 Ramdisk Mod Script
# osm0sis @ xda-developers

## AnyKernel setup
# begin properties
properties() {'
kernel.string=Sphinx Kernel v2.0 by milouk @xda-developers
do.devicecheck=1
do.modules=1
do.cleanup=1
do.cleanuponabort=0
device.name1=beryllium
'} # end properties

# shell variables
block=/dev/block/bootdevice/by-name/boot;
is_slot_device=auto;
ramdisk_compression=auto;


## AnyKernel methods (DO NOT CHANGE)
# import patching functions/variables - see for reference
. /tmp/anykernel/tools/ak2-core.sh;

## Trim partitions
fstrim -v /cache;
fstrim -v /data;

## AnyKernel file attributes
# set permissions/ownership for included ramdisk files
chmod -R 750 $ramdisk/*;
chmod -R 755 $ramdisk/sbin;
chown -R root:root $ramdisk/*;

## Alert of unsupported Android version
android_ver=$(mount /system; grep "^ro.build.version.release" /system/build.prop | cut -d= -f2; umount /system);
case "$android_ver" in
  "7.0"|"7.1"|"7.1.1"|"7.1.2") compatibility_string="Your Android Version is Unsupported. This Kernel is for Oreo and Pie";;
  "8.1.0") compatibility_string="Enjoy! ";;
esac;
ui_print "           _____       _     _             "
ui_print "          / ____|     | |   (_)            "
ui_print "         | (___  _ __ | |__  _ _ __ __  __ "
ui_print "          \___ \| '_ \| '_ \| | '_ \\ \/ / "
ui_print "          ____) | |_) | | | | | | | |>  <  "
ui_print "         |_____/| .__/|_| |_|_|_| |_/_/\_\ "
ui_print "                | |                        "
ui_print "                |_|                        "
ui_print "$compatibility_string";

## AnyKernel install
dump_boot;

# begin ramdisk changes

# init.sphinx.rc
# insert_line init.rc "import /init.sphinx.rc" after "import init.usb.rc" "import init.sphinx.rc";
insert_line init.rc "init.sphinx.rc" before "import /init.usb.configfs.rc" "import /init.sphinx.rc";

# ramdisk patch
ramdisk_patch;

# end ramdisk changes

write_boot;

## end install
